

library(magrittr)
#library(ggplot2)
#library(reshape)
#library(Matrix)
#library(directlabels)

rm(list=ls())

fold<- 'confronto'
variabile<- 'rmse1'
theta<- c(1:4,NA)
tabella<- data.frame(sigma=numeric(),G=numeric(),method=character(),stat=numeric())


statistica<- function(obj,nome,theta,ce=FALSE)
{
	p<- 1:length(theta)
	if (ce) { p<- p*2-1}
	if (nome=='ninf_bias') { {obj$estimate[p]-theta} %>% abs %>% max ->out }
	if (nome=='n1_bias') { {obj$estimate[p]-theta} %>% abs %>% sum ->out }
	if (nome=='ninf_relbias') { {(obj$estimate[p]-theta)/theta} %>% abs %>% max ->out }
	if (nome=='n1_relbias') { {(obj$estimate[p]-theta)/theta} %>% abs %>% sum ->out }
	if (nome=='tempo') { obj$tempo ->out }
	if (nome=='niter') { obj$niter ->out }
	if (nome=='code') { obj$code ->out }
	if (nome=='rmse1') { {(obj$estimate[p]-theta)[1]} %>% {.^2} ->out }
	if (nome=='rmse2') { {(obj$estimate[p]-theta)[2]} %>% {.^2} ->out }
	if (nome=='rmse3') { {(obj$estimate[p]-theta)[3]} %>% {.^2} ->out }
	if (nome=='rmse4') { {(obj$estimate[p]-theta)[4]} %>% {.^2} ->out }
	if (nome=='rmse5') { {(obj$estimate[p]-theta)[5]} %>% {.^2} ->out }
	if (nome=='bias1') { {(obj$estimate[p]-theta)[1]} ->out }
	if (nome=='bias2') { {(obj$estimate[p]-theta)[2]} ->out }
	if (nome=='bias3') { {(obj$estimate[p]-theta)[3]} ->out }
	if (nome=='bias4') { {(obj$estimate[p]-theta)[4]} ->out }
	if (nome=='bias5') { {(obj$estimate[p]-theta)[5]} ->out }
	if (nome=='nzer5') { {obj$estimate[p][5]==0} ->out }
	
	out
}

for (subfold in dir(fold))
{
	paste0(fold,'/',subfold) %>% dir -> filen
	filen %>% substr(1,6) %>% {which(.=='piano_')} %>% filen[.] %>% paste0(fold,'/',subfold,'/',.) -> filen
	load(filen)
	piano$.layer<- which(subfold==dir(fold))
	piano$.z<- NA
	
	for (j in 1:nrow(piano))
	{
		load(paste0(fold,'/',subfold,'/',piano$nomef[j],'.RData'))
		theta[5]<- piano$sigma[j]
		#gh2    %>% statistica(variabile,theta,FALSE) %>% {data.frame(sigma=piano$sigma[j],G=piano$G[j],method='Gauss-Hermite 2n  ',stat=.)} %>% rbind(tabella,.) ->tabella
		#mc250  %>% statistica(variabile,theta,FALSE) %>% {data.frame(sigma=piano$sigma[j],G=piano$G[j],method='Monte Carlo 250',stat=.)}    %>% rbind(tabella,.) ->tabella
		#mc1000 %>% statistica(variabile,theta,FALSE) %>% {data.frame(sigma=piano$sigma[j],G=piano$G[j],method='Monte Carlo 1000',stat=.)}   %>% rbind(tabella,.) ->tabella
		AGQ1   %>% statistica(variabile,theta,FALSE) %>% {data.frame(sigma=piano$sigma[j],G=piano$G[j],method='AG quadrature 1n  ',stat=.)} %>% rbind(tabella,.) ->tabella
		AGQ3   %>% statistica(variabile,theta,FALSE) %>% {data.frame(sigma=piano$sigma[j],G=piano$G[j],method='AG quadrature 3n  ',stat=.)} %>% rbind(tabella,.) ->tabella
		AGQ5   %>% statistica(variabile,theta,FALSE) %>% {data.frame(sigma=piano$sigma[j],G=piano$G[j],method='AG quadrature 5n  ',stat=.)} %>% rbind(tabella,.) ->tabella
		ce1000 %>% statistica(variabile,theta,TRUE)  %>% {data.frame(sigma=piano$sigma[j],G=piano$G[j],method='Cross-entropy 1000',stat=.)} %>% rbind(tabella,.) ->tabella
		ce2000 %>% statistica(variabile,theta,TRUE)  %>% {data.frame(sigma=piano$sigma[j],G=piano$G[j],method='Cross-entropy 2000',stat=.)} %>% rbind(tabella,.) ->tabella
		ce5000 %>% statistica(variabile,theta,TRUE)  %>% {data.frame(sigma=piano$sigma[j],G=piano$G[j],method='Cross-entropy 5000',stat=.)} %>% rbind(tabella,.) ->tabella
	}
}

tabella %>% {aggregate(.$stat,by=list(.$sigma,.$G,.$method),FUN=mean)}   %>% {colnames(.)<- c('sigma','G','method','stat'); .} ->media
#tabella %>% {aggregate(.$stat,by=list(.$sigma,.$G,.$method),FUN=median)} %>% {colnames(.)<- c('sigma','G','method','stat'); .} ->mediana
#tabella %>% {aggregate(.$stat,by=list(.$sigma,.$G,.$method),FUN=min)}    %>% {colnames(.)<- c('sigma','G','method','stat'); .} ->minimo
#tabella %>% {aggregate(.$stat,by=list(.$sigma,.$G,.$method),FUN=max)}    %>% {colnames(.)<- c('sigma','G','method','stat'); .} ->massimo
#tabella %>% {aggregate(.$stat,by=list(.$sigma,.$G,.$method),FUN=sd)}     %>% {colnames(.)<- c('sigma','G','method','stat'); .} ->sqm

#save(media,mediana,minimo,massimo,sqm,file=paste0(variabile,'.RData'))


tabella %>% {aggregate(.$stat,by=list(.$sigma,.$G,.$method),FUN=function(x) {x %>% mean %>% sqrt %>% return})} %>% {colnames(.)<- c('sigma','G','method','stat'); .} ->media

#tabella %>% {aggregate(.$stat,by=list(.$sigma,.$G,.$method),FUN=mean)} %>% {colnames(.)<- c('sigma','G','method','stat'); .} ->media

#tabella %>% {aggregate(.$stat,by=list(.$sigma,.$G,.$method),FUN=function(x) {x %>% abs %>% sum %>% return})} %>% {colnames(.)<- c('sigma','G','method','stat'); .} ->media

cat(fold,'-',variabile,'\n',file='tabelle.txt',append=TRUE)
cat('------------------------------------------\n',file='tabelle.txt',append=TRUE)
media %>% {subset(.,.$G==12)} %>% reshape(v.names='stat',timevar='sigma',idvar='method',drop='G',direction='wide') %>%
	{.[,-1] %<>% multiply_by(100) %>% as.matrix %>% formatC(digits=2,format='f',flag=' ',width=10); .} %>%
	write.table(col.names=FALSE,row.names=FALSE,quote=FALSE,file='tabelle.txt',append=TRUE)
cat('\n',file='tabelle.txt',append=TRUE)

cat(fold,'-',variabile,'\n',file='LaTeX.txt',append=TRUE)
cat('------------------------------------------\n',file='LaTeX.txt',append=TRUE)
media %>% {subset(.,.$G==12)} %>% reshape(v.names='stat',timevar='sigma',idvar='method',drop='G',direction='wide') %>%
	{.[,-1] %<>% multiply_by(100) %>% as.matrix %>% formatC(digits=2,format='f',flag=' ',width=10); .} %>%
	write.table(col.names=FALSE,row.names=FALSE,quote=FALSE,file='LaTeX.txt',append=TRUE,sep=' & ',eol=' \\\\\n')
cat('\n',file='LaTeX.txt',append=TRUE)

# media %>% {subset(.,.$G==2)} %>% reshape(v.names='stat',timevar='sigma',idvar='method',drop='G',direction='wide') %>% {.[,-1]<- round(100*.[,-1],2); .} %>% write.table(sep=' & ',eol=' \\\\\n',row.names=FALSE,quote=FALSE)








